/*#############################################################################
 TabDemo
 Author: Shooter Kennett
 Date: 14 Dec 2010
 Current build: Release Rev 0
 Project Template: Donkey's Dlg_TemplateA.tpl
 Objective: Build a demo from an existing MASM32 / RadASM 2.x project
	illustrating the use of the Win32 API control, TabStrip. The original MASM32
	files are located: .\TabDemo1\Original MASM32 Example\
	
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 Note: When an instruction set such as INVOKE is commented out, that means that
 	the commands directly below it, up to the 'end' statement are the ASM's way
 	of doing the same thing, except that 'end' is only meant to illustrate the 
 	end of said instruction set and not meant to be used.

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 Immediate Files:
	TabDemo1.asm
	TabDemo1.h
	TabDemo1.rc
 Remote Files:
 	Windows.h
	Commctrl.h

 Editor: RadASM 3.0.0.7g 
 Assembler: GoASM
	Command line: /c /x86
 Resource compiler: GoRC
	Command line: /r
 Linker: GoLink
	Command line: $C $M $R
 Debugger: OllyDbg (Launch from command line, does not work from within	RadASM.)
 	Command Line: none
###############################################################################
*/
#include "TabDemo1.h"

DATA SECTION
	hInstance	HANDLE		?
	hWin		HANDLE		?
	hTab		dd			?
	SelTab		dd			0
	hTabDlg		dd 			3 dup ?
	
	NULL		equ			0
	FALSE		equ			0
	TRUE		equ			1
	
IDD_TAB1                equ 2000
IDC_TAB1EDT1            equ 2001
IDC_TAB1STC1            equ 2002
IDD_DLG1                equ 1000
IDC_TAB1                equ 1001
IDD_TAB2                equ 3000
IDC_TAB2EDT1            equ 3001
IDC_TAB2EDT2            equ 3002
IDD_TAB3                equ 4000
IDC_TAB3EDT1            equ 1001
IDC_TAB3EDT2            equ 4002
IDC_TAB3EDT3            equ 4003
	
	TabTitle1	db			"Tab1",0
	TabTitle2	db			"Tab2",0
	TabTitle3	db			"Tab3",0
	
	ErrorCapt	db			"TabDemo1 Error",0
	ErrorMsg1	db			"Error initializing the window.",0
	
CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls

	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0

	invoke ExitProcess,0

DlgProc FRAME hWin,uMsg,wParam,lParam
	LOCAL	ts:TC_ITEM

;==============================================================================
.WM_INITDIALOG
	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_NOTIFY
		;Create the tabs
		;Even though the TabStrip has been drawn on the main dailog of the application using the
		;	resource editor, Windows still needs to have messages sent to it in order to set the 
		;	control	up correctly.
		
		;INVOKE GetDlgItem [hWin],IDC_TAB1
		push IDC_TAB1			;int nIDDlgItem, Specifies the identifier of the control to be 
								;	retrieved.
		push [hWin]				;HWND hDlg, Identifies the dialog box that contains the control.
		call GetDlgItem  
		;end INVOKE
		cmp eax,0				;0=Error, otherwise the handle is returned in EAX
		je >>.Error
		;If no error, continue...
		mov	D[hTab],eax			;Store the Tab Control's handle
		mov	w[ts.mask],\		;Store the Mask: (bit meanings unknown at this time)
			TCIF_TEXT \
			or TCIF_PARAM
		mov	b[ts.lpReserved1],0	;UINT lpReserved1, reserved, do not use
		mov	b[ts.lpReserved2],0	;UINT lpReserved2, reserved, do not use
		mov	b[ts.iImage],-1		;int iImage, index to tab control's image, none in this case
		
;------------------------------------------------------------------------------
		
		;Create the tab dialog 1
		;INVOKE CreateDialogParam,[hInstance],IDD_TAB1,[hWin],addr Tab1Proc,0		
		push 0					;LPARAM dwInitParam, initialization value passed to procedure??
		push addr Tab1Proc		;DLGPROC lpDialogFunc, address of dialog box procedure
		push [hTab]				;HWND hWndParent, handle of owner window
		push IDD_TAB1			;LPCTSTR lpTemplateName, identifies dialog box template
		push [hInstance]		;HINSTANCE hInstance, handle of application instance
		call CreateDialogParam	;If the function succeeds, the return value is the window handle 
								;	of the dialog box. If the function fails, the return value is
								;	NULL.
		;end INVOKE
		
		;Store the stuff for the next routine, TCM_INSERTITEM (TC_ITEM)
		mov	d[ts.lParam],eax	;Store the dialog handle into TC_ITEM's lParam parameter
		mov	d[ts.pszText], \	;Store Tab's Title into TC_ITEM's pszText parameter
			OFFSET TabTitle1
		mov	d[ts.cchTextMax],\	;Store the size of the Tab's Title into TC_ITEM's cchTextMax
			sizeof TabTitle1
		
		;Insert the tab
		;INVOKE SendMessage,[hTab],TCM_INSERTITEM,0,addr ts
		push addr ts			;LPARAM lParam, second message parameter, TC_ITEM complete
		push 0					;WPARAM  wParam, first message parameter, Tab Order 0
		push TCM_INSERTITEM		;UINT  uMsg, message to send, Insert a TabControl Tab
		push [hTab]				;HWND  hwnd, handle of the targeted control, TabControl Handle
		 						;Tell Windows to load IDD_TAB1's proc to the first tab
		call SendMessage		;The return value specifies the result of the message processing
								;	and depends on the message sent.
		;end INVOKE

;------------------------------------------------------------------------------
		
		;Create the tab dialog 2
		;invoke CreateDialogParam,[hInstance],IDD_TAB2,[hTab],addr Tab2Proc,0
		push 0					;LPARAM dwInitParam, initialization value passed to procedure??
		push addr Tab2Proc		;DLGPROC lpDialogFunc, address of dialog box procedure
		push [hTab]				;HWND hWndParent, handle of owner window
		push IDD_TAB2			;LPCTSTR lpTemplateName, identifies dialog box template
		push [hInstance]		;HINSTANCE hInstance, handle of application instance
		call CreateDialogParam	;If the function succeeds, the return value is the window handle 
								;	of the dialog box. If the function fails, the return value is
								;	NULL.
		;end INVOKE

		;Store the stuff for the next routine, TCM_INSERTITEM (TC_ITEM)
		mov	d[ts.lParam],eax	;Store the dialog handle into TC_ITEM's lParam parameter
		mov	d[ts.pszText], \	;Store Tab's Title into TC_ITEM's pszText parameter
			OFFSET TabTitle2
		mov	d[ts.cchTextMax],\	;Store the size of the Tab's Title into TC_ITEM's cchTextMax
			sizeof TabTitle2

		;Insert the tab
		;invoke SendMessage,[hTab],TCM_INSERTITEM,1,addr ts
		push addr ts			;LPARAM lParam, second message parameter, TC_ITEM complete
		push 1					;WPARAM  wParam, first message parameter, Tab Order 1
		push TCM_INSERTITEM		;UINT  uMsg, message to send, Insert a TabControl Tab
		push [hTab]				;HWND  hwnd, handle of the targeted control, TabControl Handle
		 						;Tell Windows to load IDD_TAB2's proc to the second tab
		call SendMessage		;The return value specifies the result of the message processing
								;	and depends on the message sent.
		;end INVOKE
		
;------------------------------------------------------------------------------		
		
		;Create the tab dialog 3
		;invoke CreateDialogParam,[hInstance],IDD_TAB3,[hTab],addr Tab2Proc,0
		push 0					;LPARAM dwInitParam, initialization value passed to procedure??
		push addr Tab3Proc		;DLGPROC lpDialogFunc, address of dialog box procedure
		push [hTab]				;HWND hWndParent, handle of owner window
		push IDD_TAB3			;LPCTSTR lpTemplateName, identifies dialog box template
		push [hInstance]		;HINSTANCE hInstance, handle of application instance
		call CreateDialogParam	;If the function succeeds, the return value is the window handle 
								;	of the dialog box. If the function fails, the return value is
								;	NULL.
		;end INVOKE

		;Store the stuff for the next routine, TCM_INSERTITEM (TC_ITEM)
		mov	d[ts.lParam],eax	;Store the dialog handle into TC_ITEM's lParam parameter
		mov	d[ts.pszText], \	;Store Tab's Title into TC_ITEM's pszText parameter
			OFFSET TabTitle3
		mov	d[ts.cchTextMax],\	;Store the size of the Tab's Title into TC_ITEM's cchTextMax
			sizeof TabTitle3

		;Insert the tab
		;invoke SendMessage,[hTab],TCM_INSERTITEM,1,addr ts
		push addr ts			;LPARAM lParam, second message parameter, TC_ITEM complete
		push 2					;WPARAM  wParam, first message parameter, Tab Order 2
		push TCM_INSERTITEM		;UINT  uMsg, message to send, Insert a TabControl Tab
		push [hTab]				;HWND  hwnd, handle of the targeted control, TabControl Handle
		 						;Tell Windows to load IDD_TAB3's proc to the third tab
		call SendMessage		;The return value specifies the result of the message processing
								;	and depends on the message sent.
		;end INVOKE
	
;------------------------------------------------------------------------------	
		jmp >>.EXIT
;==============================================================================
.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >>.WM_CLOSE
	
		mov	eax,[lParam]		;Not sure what's going on here yet. Does lParam
								;	contain the parent's window handle?
		mov	eax,\
			[eax + NMHDR.code]	;The NMHDR structure contains information about 
								;	a notification message.

		cmp eax,TCN_SELCHANGE	;The TCN_SELCHANGE notification message notifies
		jne >>.WM_CLOSE			;	a tab control's parent window that the currently
								;	selected tab has changed. This message is sent
								;	in the form of a WM_NOTIFY message.

			;Tab selection
			;INVOKE SendMessage,[hTab],TCM_GETCURSEL,0,0
			push 0				;LPARAM lParam, second message parameter, Nothing
			push 0				;WPARAM  wParam, first message parameter, Nothing
			push TCM_GETCURSEL	;UINT uMsg, message to send, Returns the index of the selected
			push IDC_TAB1		;	tab if successful or -1 if no tab is selected.
			;push [hTab]			;HWND hwnd, handle of the targeted control, TabControl Handle
			call SendDlgItemMessage	;The return value specifies the result of the message processing
								;	and depends on the message sent. 
			cmp D[hTab],-1		;Was a tab selected?
			je >>.EXIT			;No? Then exit.
			;end INVOKE
	
			cmp eax, [SelTab]	;I'm not sure how EAX plays in this one. 
			je >>.WM_CLOSE		;	Original MASM32 code: (if eax!=SelTab)
			
			push eax			;Store this on the stack for the Show Tab routine

			;Hide the current tab so that the selected tab can be shown.
			mov	w[ts.mask], \	;We want to know if the lParam member of TC_ITEM is valid.
				TCIF_PARAM
			
			;INVOKE SendMessage,[hTab],TCM_GETITEM,[SelTab],addr ts				
			push addr ts		;LPARAM lParam, second message parameter, Load the TC_ITEM 
								;	structure we want to query.
								;	Pointer to a TC_ITEM structure that specifies the information
								;	to retrieve and receives information about the tab.
			push [SelTab]		;WPARAM  wParam, first message parameter, Chose which tab 
								;	to hide, 0, 1, or 2.
			push TCM_GETITEM	;UINT  uMsg, message to send, Retrieve info about our tab
			push [hTab]			;The handle of the tab control
			call SendMessage	;The return value specifies the result of the message processing
								;	and depends on the message sent. 
			;end INVOKE
			 
			;INVOKE ShowWindow,[ts.lParam],SW_HIDE
			push SW_HIDE		;int nCmdShow, show state of window, SW_HIDE: Hides the window
								;	and activates another window.
			push [ts.lParam]	;HWND hwnd, handle of window
			call ShowWindow		;If the window was previously visible, the return value is TRUE.
								;	If the window was previously hidden, the return value is FALSE.
			;end INVOKE
			
			pop	eax				;Restore EAX for the Show Tab routine
			mov	[SelTab],eax
			
			;INVOKE SendMessage,[hTab],TCM_GETITEM,[SelTab],addr ts
			push addr ts		;LPARAM lParam, second message parameter, Load the TC_ITEM 
								;	structure we want to query.
								;	Pointer to a TC_ITEM structure that specifies the information
								;	to retrieve and receives information about the tab.
			push [SelTab]		;WPARAM  wParam, first message parameter, Chose which tab 
								;	to hide
			push TCM_GETITEM	;UINT  uMsg, message to send, Retrieve info about our tab
			push [hTab]			;The handle of the tab control
			call SendMessage	;The return value specifies the result of the message processing
								;	and depends on the message sent. 
			;end INVOKE			

			;INVOKE ShowWindow,[ts.lParam],SW_SHOWDEFAULT
			push SW_SHOWDEFAULT	;int nCmdShow, show state of window; SW_SHOWDEFAULT: Sets the show 
								;	state based on the SW_flag specified in the STARTUPINFO 
								;	structure passed to the CreateProcess function by the 
								;	program that started the application. An application should
								;	call ShowWindow with this flag to set the initial show state 
								;	of its main window.
			push [ts.lParam]	;HWND hwnd, handle of window,
			call ShowWindow		;If the window was previously visible, the return value is TRUE.
								;	If the window was previously hidden, the return value is FALSE.
			;end INVOKE			
		jmp >>.EXIT
;==============================================================================
.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >>.EXIT
		;INVOKE EndDialog,[hWin],0
		push 0					;int nResult, value to return, Specifies the value to be 
								;	returned to the application from the function that
								;	created the dialog box.
		push [hWin]				;HWND hDlg, handle of dialog box, Identifies the dialog 
								;	box to be destroyed.
		call EndDialog
		;end INVOKE
;==============================================================================
.Error
	;INVOKE MessageBox NULL,addr ErrorMsg1,addr ErrorCapt, MB_OK
	;push MB_OK					;UINT uType, style of message box, Specifies the contents
								;	and behavior of the dialog box: MB_OK: The message
								;	box contains one push button: OK.
	;push addr ErrorCapt			;LPCTSTR lpText, address of text in message box; Points
								;	to a null-terminated string containing the message to
								;	be displayed.
	;push addr ErrorMsg1			;LPCTSTR lpCaption, address of title of message box; Points
								;	to a null-terminated string used for the dialog box title.
								;	If this parameter is NULL, the default title Error is used.
	;push NULL					;HWND hWnd, handle of owner window, Identifies the owner window
								;	of the message box to be created. If this parameter is NULL,
								;	the message box has no owner window.
	;Call MessageBox
	;end INVOKE

	;INVOKE EndDialog,[hWin],0
	;push 0					;int nResult, value to return, Specifies the value to be 
							;	returned to the application from the function that
							;	created the dialog box.
	;push [hWin]				;HWND hDlg, handle of dialog box, Identifies the dialog 
							;	box to be destroyed.
	;call EndDialog
	;end INVOKE
	
;==============================================================================
.EXIT
	mov eax, TRUE
	ret
ENDF

;I'm not really sure what the following procedures are for, what exactly they do,
;	or why there has to be more than one.
Tab1Proc FRAME hWin,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >.EndTab1Proc
		mov	eax,TRUE
		ret
.EndTab1Proc
	mov	eax,FALSE
	ret

endf

Tab2Proc FRAME hWin,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >.EndTab2Proc
		mov	eax,TRUE
		ret
.EndTab2Proc
	mov	eax,FALSE
	ret

endf
	
Tab3Proc FRAME hWin,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >.EndTab3Proc
		mov	eax,TRUE
		ret
.EndTab3Proc
	mov	eax,FALSE
	ret

endf
